#include <fstream>
#include <cassert>
#include <vector>

using namespace std;

vector<int> lista_ad_grafo[200000];
int N,M;
int id_padri[200000];
bool isNodoAperto[200000];
vector<int> ciclo;
int corrispondenze[100000];

int dfs(int n, int d);

int main()
{ 
  ifstream fin("input.txt"); assert(fin);
  ofstream fout("output.txt"); assert(fout);
  fin >> N >> M;
  
  for(int i=0; i < M; i++)
  {
      int x,y;
      fin >> x >> y;
      y = y+N;
      
      if(i<N)
         lista_ad_grafo[x].push_back(y);
      else
         lista_ad_grafo[y].push_back(x);
  }
  
  for(int i=0; i<N;i++)
  {
     while(i<N && id_padri[i])
           i++;
     if(i<N && dfs(i,i))
     {
          for(unsigned i=1; i < ciclo.size(); i++)
               if(ciclo[i-1]<N)
                    corrispondenze[ciclo[i-1]] = ciclo[i];
          
          for(int i=0; i<N; i++)
               if(!corrispondenze[i])
                    corrispondenze[i] = lista_ad_grafo[i][0];

          for(int i=0; i<N; i++)
                 fout << i << " " << corrispondenze[i]-N << "\n";
          return 0;
      }
   }
   fout << "-1\n";
   fin.close();
   fout.close();
   return 0;
}
              
int dfs(int n, int d)
{
  id_padri[n] = d+1;
  isNodoAperto[n] = true;
  for(unsigned i=0; i<lista_ad_grafo[n].size(); i++)
  {
     if(isNodoAperto[lista_ad_grafo[n][i]])
     {
         ciclo.push_back(lista_ad_grafo[n][i]);
         int t = n;
         ciclo.push_back(t);
         while(t != lista_ad_grafo[n][i])
         {
             t = id_padri[t]-1;
             ciclo.push_back(t);
	 }
         return true;
     }
     
     if(id_padri[lista_ad_grafo[n][i]]) 
          continue;
     
     if(dfs(lista_ad_grafo[n][i], n)) 
          return true;
  }
  
  isNodoAperto[n] = false;
  return false;
}
   
     



