#include <vector>
#include <fstream>
#include <cassert>
#ifndef NDEBUG
#  include <iostream>  // no cin cout
#endif

using namespace std;

const int MAX_M = 200000;
const int MAX_N = 100000;

int N;
int M;
vector<int>listaADJ[MAX_M];
vector<int>ciclo;
int precedenti[MAX_M];
int corrispondenze[MAX_N];
bool hantenato[MAX_M];

int dfs(int n,int d);

int main(){

    ifstream fin("input.txt"); assert( fin );
    ofstream fout("output.txt"); assert( fout );

    fin >> N >> M;

    for(int i = 0 ; i < M; i++)
    {
        int a;
        int b;
        fin >> a >> b;

        // nave a = nodo a
        // nave b = nodo b+N
        b+=N;

        if(i<N) 
            listaADJ[a].push_back(b);
        else
            listaADJ[b].push_back(a);
    }

    fin.close();

    for(int i = 0; i < N; i++)
    {
        while (i < N && precedenti[i]) 
            i++;

        if (i < N && dfs(i,i))
        {
        for(unsigned i = 1; i < ciclo.size(); i++)
            if(ciclo[i-1]<N)
                corrispondenze[ciclo[i-1]] = ciclo[i];

        for(int i = 0; i < N; i++)
            if(!corrispondenze[i])
                corrispondenze[i] = listaADJ[i][0];

        for(int i = 0; i < N; i++)
            fout << i << " " << corrispondenze[i]-N << endl;
            return 0;
        }
    }
    
    fout << "-1" << endl;
    fout.close();
    return 0;
}

int dfs(int n,int d)
{
    //apro la ricerca
    hantenato[n] = true;

    //padre del nodo a quello precedente
    precedenti[n] = d+1;

    for(unsigned i = 0; i < listaADJ[n].size(); i++)
    {
        //ho trovato un ciclo
        if(hantenato[listaADJ[n][i]])
        {
            ciclo.push_back(listaADJ[n][i]);
            int t = n;
            ciclo.push_back(t);

            while(t != listaADJ[n][i])
            {
                t = precedenti[t]-1;
                ciclo.push_back(t);

            }

        return true;
        }

        if(precedenti[listaADJ[n][i]])
            continue;

        if(dfs(listaADJ[n][i], n))
            return true;
    }

    hantenato[n]=false;
    return false;
}

