//#include <iostream>
#include <fstream>
#include <cassert>
#include <vector>
using namespace std;

/* il problema richiede di essere rappresentato con un grafo bipartito
 per rappresentarlo scelgo la lista di adiacenza, così possiamo orientare gli archi. 

I primi N nodi saranno messaggi (0,N-1), da (N,2*N-1) navi.

*/
vector<int> graph[200000];
int N,M;
/* Array ausiliario per salvare i padri durante visita dfs*/
int padri[200000];
/* Per marcare i nodi che sto visitando nella dfs */
bool marked[200000];
//Per contenere un ciclo.
vector<int> cycle;
//match messaggio - nave
int new_match[100000];

//esegue una dfs allo scopo di trovare un ciclo. Se trovo un nodo già marcato significa che vi sono ritornato
//quindi ho un ciclo.
int dfs(int n,int d){
    //cout<<"nodo "<<n<<endl;
    //assegno il padre del nodo considerato, marco il nodo.
    padri[n]=d+1;
    marked[n]=true;
    
    //visito tutti i figli
    for(unsigned i=0; i<graph[n].size(); i++){
        //cout<<i<<endl;
        //cout<<marked[graph[n][i]]<<endl;
        //cout<<"pad :"<<padri[n]<<endl;
        //se trovo un nodo marcato allora ho trovato un ciclo.
        if(marked[graph[n][i]]){
            //quindi aggiungo al vettore che utilizzo per salvare i cicli, entrambi.
            cycle.push_back(graph[n][i]);
            int t=n;
            cycle.push_back(t);
            //ricostruisco il ciclo all'indietro, avendolo prima identificato sono sicuro che il while termina
            while(t!=graph[n][i]){
                t=padri[t]-1;
                cycle.push_back(t);
            }
            return true;
            }
            //se il figlio genera un ciclo...allora il padre con esso forma un ciclo
            if(dfs(graph[n][i],n)) return true;
        }
        //altrimenti non ho trovato un ciclo.
        marked[n]=false;
        return false;
}

int main(){

    ifstream fin("input.txt"); assert(fin);
    fin >> N;
    fin >> M;

    for(int i=0;i<M;i++){
        int a,b;
        fin >> a;
        fin >> b;
        b+=N;
        
    //creo gli archi del grafo, orientati a seconda che il nodo considerato sia un messaggio o una nave.
    if(i<N) graph[a].push_back(b);
    else graph[b].push_back(a);
    }

     ofstream fout("output.txt"); assert(fout);
    //creazione del matching

    //cerco di trovare un ciclo di archi, visitando il grafo con dfs. In questo modo riesco a trovare archi 
    // tra messaggi e navi che
    //formano una corrisponde univoca, (appartengono allo stesso ciclo). 
    for(int i=0; i<N;i++){

        while(i<N && padri[i]) i++;
        //utilizzo la dfs per verificare cicli
        if(i<N && dfs(i,i)){
           // //cout<<"dfs ok: "<<i<<endl;
        //per ogni ciclo trovato costruisco un nuovo match
            for(unsigned i=1;i<cycle.size();i++){
              // cout<<cycle[i]<<endl;
                if(cycle[i-1]<N)
                    new_match[cycle[i-1]]=cycle[i];}
        //completo la soluzione con gli archi che non erano nel ciclo.
            for(int i=0;i<N;i++)
                if(!new_match[i])
                    new_match[i]=graph[i][0];

       
        for(int i=0; i< N;i++){
            fout <<i; fout <<" "<<new_match[i]-N<<"\n";
        } return 0;
        }

   } //stampo -1 se non ci sono corrispondenze
fout<< -1<<endl;
}
