#include <string.h>
#include <queue>
#include <cassert>
#include <fstream>

using namespace std;


const int MAXN = 3000;
const int MAXM = 5000;

int A[MAXN][MAXN]; //CONTROLLARE GRANDEZZA MATRICE
int n,m;

int percorso[MAXN];
int soluzioneTouring[MAXN][2];

bool bsf(int rGraph[MAXN][MAXN]);

int main(){

    ifstream fin("input.txt");assert(fin);

    // leggo la prima riga
    fin >> n >> m;

    //Leggo l'input fino ad n righe
    int j,k;
    for(int i = 0; i < n; i++){
       fin >> j >> k;
       A[j][k] = 1;
       soluzioneTouring[i][0] = j;
       soluzioneTouring[i][1] = k;
    }

    // Leggo l'input per le restanti righe
    for(int i = n; i < m; i++){
        fin >> j >> k;
        A[j][k] = 1;
    }

   bool unica = true;
   for(int i = 0; i < n; i++){ // per tutta la soluzione di touring controllo che ci sian una corrispondenza
       A[soluzioneTouring[i][0]][soluzioneTouring[i][i]] = 0;
       if(bsf(A)){
           unica = false;
           break;
       }
       A[soluzioneTouring[i][0]][soluzioneTouring[i][i]] = 1;
   }

   FILE *fout = fopen ("output.txt", "w"); assert( fout );

   if(unica){
       fprintf(fout,"-1");
   }else{
       for(int i = 0; i < n; i++){
           fprintf(fout,"%d %d\n",i,percorso[i]);
       }
   }

   fclose(fout);

}

// FUNZIONI AUSILIARIE

bool bsf(int rGraph[MAXN][MAXN]){

    int visited[n];
    memset(visited,-1,sizeof(visited));
    bool find = false;
    for(int u = 0; u < n; u++)
        visited[u] = -1;
    for(int i = 0; i < n; i++){ // per tutti i messaggi
        find = false;
        for(int j = 0; j < n; j++){ // per tutte le navi
            if(rGraph[i][j]== 1 && visited[j] == -1){ // se nel grafo c'è un collegamento e la nave nn è ancora stata visitata
                visited[j] = i;
                find = true;
                break;
            }
        }
        if(find == false){
            for(int k = 0; k < n; k++){ // per ogni nave
                if(rGraph[i][k] == 1){
                   rGraph[visited[k]][k] = 0;
                   if(bsf(rGraph)){
                       visited[k] = i;
                       return true;
                   }else { rGraph[visited[k]][k] = 1;}
                }
            }
         return false;
        }
    }
    for(int j = 0; j < n; j++){
        percorso[j] = visited[j];
        percorso[j] = visited[j];
    }
    return true;
}
