#include <fstream>
#include <stdlib.h>


using namespace std;

int n;
int m;
int* result;


void message(int** matrix, int from, int to, int turing){
    if (turing > 0)
        matrix[from][to] = 2;
    else
        matrix[from][to] = 1;
}

void zeros(int** matrix){
    for (int i=0; i<n; i++){
        for (int j=0; j<n; j++){
            matrix[i][j] = 0;
        }
    }
}



int findShip(int** matrix, int col){
    if (col == n)
        return 2;
    
    for (int i=0; i<n; i++){
        if (matrix[i] != NULL && matrix[i][col] > 0){
            int* temp = matrix[i];
            matrix[i] = NULL;
            if (findShip(matrix, col+1) > 0){
                result[i] = col;
                return 1;
            }
            matrix[i] = temp; 
        }
    }

    return 0;
}


void alternativeMatching(int** matrix){
    char * res = (char*) malloc(7*m * sizeof(char));
    ofstream fout("output.txt");

    for (int i=0; i<n; i++){
        for (int j=0; j<n; j++){
            if (matrix[i][j] == 2){
                matrix[i][j] = 0;
                if (findShip(matrix, 0) > 0){
                    for (int k=0; k<n; k++)
                        fout << k << " " << result[k] << endl;
                    fout << endl;
                    return;
                } 
                matrix[i][j] = 2;
            }
            
        }
        
    }
    
    fout << "-1" << endl;
}


int** construct_matrix(int rows, int cols){
    int** m = (int**) malloc(rows * sizeof(int*));

    for (int k=0; k<rows; k++){
        m[k] = (int*) malloc(cols * sizeof(int));
    }

    return m;
}



int main(){
    ifstream fin("input.txt");
    fin >> n;
    fin >> m;

    int** matrix = construct_matrix(n, n);
    result = (int*) malloc(m * sizeof(int));
    zeros(matrix);

    int from, to;

    for (int k=0; k<m; k++){
        fin >> from;
        fin >> to;
        if (k<n) message(matrix, from, to, 1);
        else message(matrix, from, to, 0);
    }
    fin.close();

    alternativeMatching(matrix);


    return 0;
}
